from Products.CMFCore.utils import getToolByName

INSTALL_PRODUCTS = ['easyshop.core']

def siteSetup(context):

    if context.readDataFile('koehsel.policy_setup.txt') is None:
        return

    site = context.getSite()

    # Install EasyShop product

    qi = getToolByName(site, 'portal_quickinstaller')
    for p in INSTALL_PRODUCTS:
        if not qi.isProductInstalled(p):
            qi.installProduct(p)

    # Add and publish shop instance

    try: site.shop
    except AttributeError:
        site.invokeFactory(id='shop', type_name='EasyShop')
        shop = site.shop
        shop.title = 'Shop'
        shop.shopOwner = 'admin'
        wf = getToolByName(site, 'portal_workflow')    
        if wf.getInfoFor(shop,'review_state','') != 'published':
            wf.doActionFor(shop,'publish',comment='site setup')

    # Hide Users, News and Events

    for id in ('Members', 'news', 'events'):
        ob = getattr(site,id)
        if wf.getInfoFor(ob,'review_state','') != 'private':
            wf.doActionFor(ob,'retract',comment='site setup')


# Called via hackery in __init__.py
def appInit(app):
    try: app.site
    except AttributeError:
        app.manage_addProduct['CMFPlone'].addPloneSite(id='site',
                                                       extension_ids=['koehsel.policy:default'])
